function V = milstein(r, v, vav, n, p, l, S0, K, T, N, M)

dt = T/N;
x(1:M) = log10(S0); %loc prices vector, starts at S0
v(1:M) = v; %log variance vector, starts a passed value v
for i=1:N-1;
    ro1 = randn(1,M); % Calculate standard normal 1
    ro2 = p*ro1+sqrt(1-p^2)*randn(1,M); % Calculate standard normal 2
    x = x + r*dt -v/2*dt + sqrt(v*dt).*ro1; %Calculate new price
    %Calculate new volatility, using the second normal
    v = abs((sqrt(v) + n/2*sqrt(dt)*ro2).^2-l*(v-vav)*dt-n^2/4*dt); 
end
St = 10.^x;% return from log-land
V = max(St-K,0); % calculate call option value
V = mean(V); %take average and return as a single price
end